#include "Hat.inc"
#include "Bottle1.inc"
#include "Bottle2.inc"
#include "Vase1.inc"
#include "Mirror.inc"

#declare Plank = box {
	<0,0,-150>,<10,10000,0>
	texture {
		T_Wood2
		scale 20
//		pigment { color White }
	}
}

#declare Shelf = union {
	intersection {
		object { Plank translate x*-10 }
		plane { y,900 }
	}
	intersection {
		object { Plank translate x*500 }
		plane { y,900 }
	}
	intersection {
		object { Plank translate x*245 }
		plane { y,650 }
	}
	intersection {
		object { Plank rotate z*-90 translate <-15,10> }
		plane { x,515 }
	}
	intersection {
		object { Plank rotate z*-90 translate y*650 }
		plane { x,500 }
	}
	intersection {
		object { Plank rotate z*-90 translate <250,250> }
		plane { x,500 }
	}
	intersection {
		object { Plank rotate z*-90 translate <-15,900> }
		plane { x,515 }
	}
	object { Hat scale 100 translate < 125,10,-75 >  }
	object { Bottle1 rotate y*20 scale 120 translate < 125+250-25,10,-80 > }
	object { Bottle2 scale 150 translate < 125+250-30,250,-90 > }
	object { Vase1 translate < 100,650,-80 > }

	#declare BookH = 300
	#declare BookW = 50
	#declare BookL = 200

	#declare T_Book1 = texture {
		pigment { color rgb < 0.8, 0.4, 0.0 > }
		finish { phong 0.3 }
		normal {
			bozo 0.02
			scale 5/BookH
		}
	}
	#declare T_Book2 = texture {
		pigment { color rgb < 1.0, 0.8, 0.01>*.7 }
		finish { phong 1.0 metallic brilliance 2 }
		normal {
			crackle 0.04
			scale 40/BookH
		}
	}

	#declare T_Book = texture {
		gradient y
		texture_map {
			[ 0.00 T_Book1 ]
			[ 0.10 T_Book1 ]
			[ 0.10 T_Book2 ]
			[ 0.15 T_Book2 ]
			[ 0.15 T_Book1 ]
			[ 0.80 T_Book1 ]
			[ 0.80 T_Book2 ]
			[ 0.90 T_Book2 ]
			[ 0.90 T_Book1 ]
		}
		scale BookH
	}
	#declare BookTitle=""
	#include "Book.inc"
	object { Book rotate y*-90 rotate z*-90 rotate y*3 translate < 200,650,0 > }

	#declare BookH = 240
	#declare BookW = 60
	#declare BookL = 160
	#declare T_Book = texture {
		pigment {
			bozo
			color_map {
				[0.0 rgb < 1.0, 0.1, 0.1 > ]
				[1.0 rgb < 0.8, 0.0, 0.0 > ]
			}
			scale 3
		}
		finish { phong 0.3 }
	}
	#declare BookTitle = " Magi III"
	#declare T_Title = texture {
		pigment { rgb < 1.0, 0.8, 0.2 > }
		finish {
			specular 0.5
		}
	}
	#include "Book.inc"
	object { Book rotate y*-90 rotate z*-90 translate < 230,650+50,-10 > }
	object { Mirror rotate y*-10 translate <160,900,-80> }
}
